{
////////////////////////////////////////////////////////////////////////////////
TMSNMESSENGER Component for Borland(R) Delphi(TM) 5,6,7

                Copyright 2003 Angelo Perera

Name: TMSNMessenger
Author: Angelo Perera
Version: 2.5Beta
Date Released: 08/04/03

Contact Details: angelo_terminal@hotmail.com (no spam please!)

  >>PLEASE READ THE README.txt FILE FOR FULL INSTALLATION AND OTHER DETAILS!<<

Installtion Details: 1. Add this folder to the library path (enviromental options)
                     2. Open the dpk file and hit install
                     3. Open the Demo Project and have a look at how it works!

Release History:

08.04.03 TMSNChatSession Component Finished
         List Handling patched up
         Code Cleaned up

Procedures for next update
* Fix List errors
* Fix User Start typing command in Chat Component

}

unit XTMsnMessenger;

interface

uses
  SysUtils, Classes,SimpleTCP,HashAlg_U, HashAlgMD5_U,forms,dialogs, ExtCtrls;


Const
    BEEP = #13 + #10;

type
TOnlineUser=Record
email,Status:string;
end;

type
TStringList=Record
Data:Array of string;
end;

Type
TGroup=Record

end;
type
TChatSession = record
CurrentUserEmail,CurrentUserName,CKIID,Session,Mode,ChatPartner,Host,Port:string;
end;


type
TUInfo=Record
UserId,Password,FriendlyName,Status ,
PreferredEmail,
Country,
MSPAuth,
Gender,
PhoneNumber,WorkNumber,MobileNumber,
InboxURL,
FoldersURL,
PostURL
:String;

InboxUnread,
FoldersUnread,
Lang_preference,
BDayPre,
PostalCode,
LoginTime,
MemberIdHigh,
MemberIdLow,
Birthday,
Age,
Flags,
sid,
kv:Integer;

Wallet,MobilePager,MBE,
EmailEnabled,
Kid:Boolean;

end;

type
TBuddy=Record
FriendlyName,EmailAddress,PhoneNumber,WorkNumber,MobileNumber,MSNMobile:String;
Group:Integer;
end;

type
TBuddyList=Record
BuddiesOnList:array of TBuddy;
end;

type
  TMsnMessenger = class(TComponent)
  private

{Events}
FOnConnect,
FOnConnected,
FOnLogin,
FOnLogout,
FOnDisconnect,
FOnProgress,
FOnStatus,
FOnStatsChanged,
FOnUserWentOnline,
FOnUserWentOffline,
FOnBlockUser,
FOnUnblockUser,
FOnBuddyListChange,
FOnListChange,
FOnError,
FOnAddedUser,
FOnDeletedUser,
FOnReadData,
FOnWriteData,

FOnChatYouRequestBuddy,
FOnChatBuddyRequestYou:TNotifyEvent;

FriendsListChanged:Boolean;

{Components}
MSN:TSimpleTCPClient;
MD5Hash:THashAlgMD5;
Fid:Integer;
Timer:TTimer;
ListTimer:TTimer;

OnlineUserz:array of string;

{Data}
FUserID,FUserFriendlyName,FPassword,FUserStatus:String;

FMSNUserInformation:TUInfo;

FMSNStatus:String;

FConnectionProgress:Integer;

FLoggedIn:Boolean;

{List}
ListData:Array of String;
Procedure DecodeList(Data:String);
Procedure DecodeListILN(Data:String);

//Function SplitString(Data:String):TStringList;

{Component Results}

    procedure SimpleTCPClient1Connected(Sender: TObject);
    procedure SimpleTCPClient1Disconnected(Sender: TObject);
    procedure SimpleTCPClient1Error(Sender: TObject; Socket,
      ErrorCode: Integer; ErrorMsg: String);
    procedure SimpleTCPClient1Read(Sender: TObject; Stream: TStream);

    procedure OnTimer(Sender: TObject);
    procedure OnListTimer(Sender: TObject);

Function AddUserToList(BuddyList:TBuddyList;User:Tbuddy):TBuddyList;
Function RemoveUserFromList(BuddyList:TBuddyList;User:Tbuddy):TBuddyList;
//Function ClearList(BuddyList:TBuddyList):TBuddyList;

Procedure SendMessage(Data:String);

Function MD5(Data:String):String;
Procedure GetLists;
function Xid:string;

Procedure AddOnlineUser(Email,Status:String);

Function CustomUser(FriendlyName,Email,Status,Phone,WorkPhone,Mobile,MSNMobile,Group:String):TBuddy;

{Core Procedures}

Procedure ProcessLogin(DataRecieved:String);
Procedure ProcessList(DataRecieved:String);
Procedure ProcessCommand(DataRecieved:String);


  protected
    { Protected declarations }
  public
MSNListGroups:Array of TGroup;

{lists}

MSNListFriends,
MSNListBlocked,
MSNListAddedYou,
MSNListSeeYou:TBuddylist;

MSNOnlineUsers:array of TOnlineUser;

WriteData,ReadData:String;

ChatSession:TChatSession;

{Procedures}
Procedure MSNInviteBuddy(EmailAddress:String);
Procedure MSNChangeStatus(NewStatus:String);
Procedure MSNAddBuddy(EmailAddress:String);
Procedure MSNRemoveBuddy(EmailAddress:String);
Procedure MSNBlockBuddy(EmailAddress:String);
Procedure MSNUnBlockBuddy(EmailAddress:String);
Procedure MSNChageName (NewName:String);
Procedure RefreshLists;
Procedure MSNLogin;
Procedure MSNLogout;
 published


{Secure Properties}
Property MSNUserInformation:TUInfo read FMSNUserInformation write FMSNUserInformation;

Property UserID:String read FUserID write FUserID;
Property UserPassword:String read FPassword write FPassword;
Property UserStatus:String read FUserStatus write MSNChangeStatus;
Property UserFriendlyName:String read FUserFriendlyName write FUserFriendlyName;

Property MSNStatus:String read FMSNStatus;
Property MSNConnectionProgress:integer read FConnectionProgress;



{Initilization}
Procedure Initialize;

{Events}
Property OnReadData:TNotifyEvent Read FOnReadData Write FOnReadData;
Property OnWriteData:TNotifyEvent Read FOnWriteData Write FOnWriteData;


Property OnConnect:TNotifyEvent Read FOnConnect Write FOnConnect;
Property OnConnected:TNotifyEvent Read FOnConnected Write FOnConnected;
Property OnLogin:TNotifyEvent Read FOnLogin Write FOnLogin ;
Property OnLogout:TNotifyEvent Read FOnLogout Write FOnLogout;
Property OnDisconnect:TNotifyEvent Read FOnDisconnect Write FOnDisconnect ;
Property OnProgress:TNotifyEvent Read FOnProgress Write FOnProgress ;
Property OnStatus:TNotifyEvent Read FOnStatus Write FOnStatus;
Property OnUserInformationChanged:TNotifyEvent Read FOnStatsChanged Write FOnStatsChanged ;
Property OnUserWentOnline:TNotifyEvent Read FOnUserWentOnline Write FOnUserWentOnline ;
Property OnUserWentOffline:TNotifyEvent Read FOnUserWentOffline Write FOnUserWentOffline ;
Property OnBlockUser:TNotifyEvent Read FOnBlockUser Write FOnBlockUser ;
Property OnUnblockUser:TNotifyEvent Read FOnUnblockUser Write FOnUnblockUser ;
Property OnBuddyListChange:TNotifyEvent Read FOnBuddyListChange Write FOnBuddyListChange ;
Property OnListChange:TNotifyEvent Read FOnListChange Write FOnListChange ;
Property OnError:TNotifyEvent Read FOnError Write FOnError ;
Property OnAddedUser:TNotifyEvent Read FOnAddedUser Write FOnAddedUser ;
Property OnDeletedUser:TNotifyEvent Read FOnDeletedUser Write FOnDeletedUser ;

Property OnChatYouRequestBuddy:TNotifyEvent Read FOnChatYouRequestBuddy Write FOnChatYouRequestBuddy ;
Property OnChatBuddyRequestYou:TNotifyEvent Read FOnChatBuddyRequestYou Write FOnChatBuddyRequestYou ;


Property LoggedOn:Boolean Read FLoggedIn;

  end;

procedure Register;

implementation

////////////////////////////////////////////////////////////////////////////////
{Custom Actions}
////////////////////////////////////////////////////////////////////////////////

Function SplitString(Data:String):TStringList;
var
s,ss:string;
i:integer;
begin
setlength(result.Data,0);
data:=data+'  ';
for i:=1 to length(data) do begin

s:=Copy(Data,i,1);
if (s<>' ') and {(s<>#10)and} (s<>#13)and (s<>#11) then ss:=ss+s else begin


setLength(result.data,Length(Result.data)+1);
result.data[length(result.data)-1]:=ss;

ss:='';


end;
end;
//if (ss<>'') and (length(result.data)<>0) then result.Data[length(result.data)-1]:=result.Data[length(result.data)-1]+ss;

end;


Function GetName(Data:String):String ;
var
s,ss:string;
i,ii:integer;
begin
delete(Data,1,pos('@',data));
delete(Data,1,pos(' ',data));
ss:='';
i:=1;
while s<>#13 do begin
ss:=ss+s;
s:=copy(data,i,1);
inc(i);
end;

for i:=1 to length(ss) do begin
if copy(ss,i,1)=' ' then ii:=i;

end;

result:=copy(ss,1,ii-1);


end;


Function GetGroup(Data:String):String ;
var
s:string;
begin

s:=getname(data);
delete(Data,1,pos('@',data));
delete(Data,1,pos(s,data));
delete(Data,1,Length(s));
delete(data,pos(#13,data),length(data));

delete(data,1,pos(' ',data));
delete(data,1,pos(' ',data));
delete(data,1,pos(' ',data));
delete(data,1,pos(' ',data));

result:=data;
end;

function FindTextPos(LookFor:string;INTEXT:string):integer;
var
ii:integer;

ss:string;
begin
ii:=1;
while ii<> length(INTEXT)+1 do begin
if copy(INTEXT,ii,length(lookfor))=lookfor then begin  FindTextpos:=ii  end else ss:=ss+copy(INTEXT,ii,1);
inc(ii);
end;
end;


Function GetPhone(Data:String):String ;
var
s,ss:string;
begin
ss:=data;
s:=getname(data);
delete(Data,1,pos('@',data));
delete(Data,1,pos(s,data));
delete(Data,1,Length(s));

delete(data,1,Pos(' ',data));
s:=data;

while length(SplitString(S).data)>21 do delete(S,1,Pos(' ',s));

Result:=SplitString(S).data[3]+' '+SplitString(S).data[8]+' '+SplitString(S).data[13]+' '+SplitString(S).data[18];


end;



////////////////////////////////////////////////////////////////////////////////
//Code  for interfacing with  MSN Messenger Service
////////////////////////////////////////////////////////////////////////////////


{Logging-in Procedures}
Procedure TMSNMessenger.ProcessLogin(DataRecieved:String);
var
Host,Port,data:string;
begin

Data:=DataRecieved;

if pos('911',data)<>0 then begin
FMSNStatus:='Invalid Username or Password';
if assigned(onStatus) then OnStatus(self);
if assigned(OnError) then OnError(self);
MSN.Connected:=false;
end;

if data = 'VER 0 MSNP7 MSNP6 MSNP5 MSNP4'+beep then begin
sendMessage('INF 1');
FMsnStatus:='Checking Version' ;
IF Assigned(OnStatus) then OnStatus(self);

end;

if data= 'INF 1 MD5'+beep then begin
SendMEssage('USR 2  MD5  I  '+FuserId);
FConnectionProgress:=33;
FMsnStatus:='Verifying User';
IF Assigned(OnProgress) then OnProgress(self);
IF Assigned(OnStatus) then OnStatus(self);

end;

if copy(data,1,5)='XFR 2' then begin
MSN.connected:=false;
Host:=SplitString(DataRecieved).Data[3];
port:=host;
Delete(host,pos(':',host),length(host));
Delete(port,1,pos(':',port));
port:=Copy(port,1,length(port));
msn.Connected:=false;
Msn.Host:=host;
msn.Port:=strtoint(port);

timer.enabled:=true;

end;

if copy(data,1,9)='USR 2 MD5' then begin
SendMEssage('USR 6 MD5 S '+lowercase( md5(copy(data,13,length(data)-14)+FPassword)));
FConnectionProgress:=66;
FMsnStatus:='Checking Password';
IF Assigned(OnProgress) then OnProgress(self);
IF Assigned(OnStatus) then OnStatus(self);

end;


if copy(data,1,8)='USR 6 OK' then begin
SendMessage('CHG 7 NLN');

FUserFriendlyName:=StringReplace(splitstring(data).data[4],'%20',' ',[rfReplaceAll]);;
FUserStatus:='NLN';
FLoggedin:=true;
FID:=8;
FConnectionProgress:=100;
FMsnStatus:='Password Approved. User Online.';
IF Assigned(OnProgress) then OnProgress(self);
IF Assigned(OnStatus) then OnStatus(self);
IF Assigned(OnUserInformationChanged) then OnUserInformationChanged(self);
FConnectionProgress:=0;
If Assigned(OnConnected) then OnConnected(self);
end;

end;

////////////////////////////////////////////////////////////////////////////////
//Process List Data
////////////////////////////////////////////////////////////////////////////////


{Decode List Data}
Procedure TMSNMessenger.DecodeList(Data:String);
var
i:integer;
s,ss:string;
StringArray:array of String;
begin
s:=data;
setlength(listdata,0);
while pos('LST ',s)<>0 do begin

ss:=(copy(s,1,Pos('LST',s)-1));


setlength(Stringarray,length(Stringarray)+1);
StringArray[length(stringarray)-1]:=ss;

delete(s,1,pos('LST',S)+5+(length(inttostr(fid))-1));
//showmessage(s);
end;


for i:=0 to length(StringArray)-1 do begin

setlength(Listdata,Length(ListData)+1);
Listdata[Length(listdata)-1]:=StringArray[i];

end;


end;

{Decode Online Users}
Procedure TMSNMessenger.DecodeListILN(Data:String);

var
i:integer;
s,ss,sss:string;
stringarray:array of string;
begin
setlength(onlineuserz,0);
if pos('ILN',data)=1 then begin
s:=data;
setlength(stringarray,0);
for i:= 1 to length(s) do begin
ss:=copy(s,i,1);

if (ss=#13)then begin
setlength(Stringarray,length(Stringarray)+1);
StringArray[length(stringarray)-1]:=sss;
sss:=''
end else if (ss<>#10) and (ss<>#11) then sss:=sss+ss;

end;



for i:=0 to length(StringArray)-1 do begin
setlength(onlineuserz,length(onlineuserz)+1);
s:=stringarray[i];
onlineuserz[length(onlineuserz)-1]:=s;

end;

end;

end;

////////////////////////////////////////////////////////////////////////////////
//Process Lists when Recieved
////////////////////////////////////////////////////////////////////////////////
Procedure TMSNMessenger.ProcessList(DataRecieved:String);
var
data,s,z:string;
i:integer;
begin
data:=datarecieved;
setlength(Listdata,0);

if pos('MSG',data)<>0 then begin

if pos('msmsgsprofile',data)<>0 then begin


FMSNUserInformation.PreferredEmail:=SplitString(Data).data[20];
FMSNUserInformation.Country:=SplitString(Data).data[22];
FMSNUserInformation.MSPAuth:=SplitString(Data).data[44];
FMSNUserInformation.Gender:=SplitString(Data).data[26];
FMSNUserInformation.Lang_preference:=strtoint(SplitString(Data).data[18]);
FMSNUserInformation.BDayPre:=strtoint(SplitString(Data).data[32]);
FMSNUserInformation.PostalCode:=strtoint(SplitString(Data).data[24]);
FMSNUserInformation.LoginTime:=strtoint(SplitString(Data).data[10]);
FMSNUserInformation.MemberIdHigh:=strtoint(SplitString(Data).data[14]);
FMSNUserInformation.MemberIdLow:=strtoint(SplitString(Data).data[16]);
FMSNUserInformation.Birthday:=strtoint(SplitString(Data).data[34]);
FMSNUserInformation.Age:=strtoint(SplitString(Data).data[30]);
FMSNUserInformation.Flags:=strtoint(SplitString(Data).data[38]);
FMSNUserInformation.Sid:=strtoint(SplitString(Data).data[40]);
FMSNUserInformation.kv:=strtoint(SplitString(Data).data[42]);

if SplitString(Data).data[36] = '0' then FMSNUserInformation.Wallet:=False else FMSNUserInformation.Wallet:=True;
if SplitString(Data).data[12] = '0' then FMSNUserInformation.EmailEnabled:=False else FMSNUserInformation.EmailEnabled:=False ; 
if SplitString(Data).data[28] = '0' then FMSNUserInformation.Kid:=False else FMSNUserInformation.Kid:=True;  

If Assigned(OnUserInformationChanged) then OnUserInformationChanged(self);
end else
begin

FMSNUserInformation.InboxUnread:=strtoint(SplitString(Data).data[11]);
FMSNUserInformation.FoldersUnread:=strtoint(SplitString(Data).data[13]);
FMSNUserInformation.InboxURL:=(SplitString(Data).data[15]);
FMSNUserInformation.FoldersURL:=(SplitString(Data).data[18]);
FMSNUserInformation.PostURL:=(SplitString(Data).data[20]);
If Assigned(OnUserInformationChanged) then OnUserInformationChanged(self);
end;

end;

if pos('PRP',data)<>0 then begin

FMSNUserInformation.PhoneNumber:=StringReplace(SplitString(Data).data[12],'%20',' ',[rfReplaceAll]);
FMSNUserInformation.WorkNumber:=StringReplace(SplitString(Data).data[17],'%20',' ',[rfReplaceAll]);
FMSNUserInformation.MobileNumber:=StringReplace(SplitString(Data).data[22],'%20',' ',[rfReplaceAll]);

if (SplitString(Data).data[27])='Y' then FMSNUserInformation.MobilePager:=true else FMSNUserInformation.MobilePager:=false;
if (SplitString(Data).data[32])='Y' then FMSNUserInformation.MBE :=true else FMSNUserInformation.MBE :=false;  


end;


if (pos('LST',data)<>0) then begin
DecodeList(data);

for i:=0 to length(listdata)-1 do begin

z:=Listdata[i];


if pos('FL', z)<>0 then begin
s:=Listdata[i];

MSNListFriends:=addusertolist(MsnListFriends,CustomUser(GetName(s),SplitString(s).data[4],'FLN',SplitString(GetPhone(s)).data[0],SplitString(GetPhone(s)).data[1],SplitString(GetPhone(s)).data[2],SplitString(GetPhone(s)).data[3],GetGroup(s)));
end else

if pos('BL', z)=1 then begin
s:=Listdata[i];
MSNListBlocked:=addusertolist(MsnListBlocked,CustomUser(SplitString(s).data[5],SplitString(s).data[4],'FLN','','','','',''));
end else

if pos('AL',z)=1 then begin
s:=Listdata[i];
MSNListSeeYou:=addusertolist(MsnListSeeYou,CustomUser(SplitString(s).data[5],SplitString(s).data[4],'FLN','','','','',''));
end else

if pos('RL', z)=1 then begin
s:=Listdata[i];
MSNListAddedYou:=addusertolist(MsnListAddedyou,CustomUser(SplitString(s).data[5],SplitString(s).data[4],'FLN','','','','',''));
end;

listtimer.Enabled:=false;
listtimer.Enabled:=true;


end;



end;

////////////////////////////////////////////////////////////////////////////////
//General Session Commands
////////////////////////////////////////////////////////////////////////////////

{Prcocess General Session Commands}

end;
Procedure TMSNMessenger.ProcessCommand(DataRecieved:String);
var
x,data:string;
mail,sesid,hostid,ckiid:string;
i:integer;
begin
data:=DataRecieved;

ProcessList(DataRecieved);

//Someone Requests a Chat with you!
if copy(data,1,3)='CHL' then begin
x:=('QRY 10 msmsgs@msnmsgr.com 32'+beep+lowercase(md5(copy(data,7,20)+'Q1P7W2E4J9R8U3S5')));
MSN.Send(pchar(X),Length(X));

end;


      if Pos('RNG', Data) = 1 then
      begin
//RNG 168379 207.46.108.2:1863 CKI 1048066303.9824 <email> <name>
        SesId := SplitString(Data).data[1];
        HostId := SplitString(Data).data[2];;
        CKIid := SplitString(Data).data[4];
        mail := SplitString(Data).data[5];

        ChatSession.CurrentUserEmail:=FUserID;
        ChatSession.CurrentUserName:=FUSerFriendlyName;
        ChatSession.Session:=SesId;

ChatSession.Host:=HostId;
Delete(ChatSession.Host,Pos(':',ChatSession.Host),length(ChatSession.Host));
Delete(HOSTID,1,Pos(':',HOSTID));
Chatsession.Port:=HOSTID;

        ChatSession.Mode:='1';
        ChatSession.ChatPartner:=Mail;
        ChatSession.CKIID:=CKIID;
        If Assigned (OnChatbuddyRequestYou) then OnChatBuddyRequestYou(Self);
      end;


//After you requested a Chat you get this reply
if (copy(data,1,3) = 'XFR') and (Pos('SB',DAta)<>0) then begin
///XFR 10 SB 64.4.12.193:1863 CKI 16925950.1016955577.17693

        HostId := SplitString(Data).data[3];
        CKIid := SplitString(Data).data[5];

ChatSession.CurrentUserEmail:=FUserId;
ChatSession.CurrentUserName:=FUserFriendlyName;
ChatSession.CKIID:=CKIID;
ChatSession.Host:=HostId;
Delete(ChatSession.Host,Pos(':',ChatSession.Host),length(ChatSession.Host));
Delete(HOSTID,1,Pos(':',HOSTID));
Chatsession.Port:=HOSTID;
ChatSession.Mode:='0';

If Assigned(OnChatYouRequestBuddy) then OnChatYouRequestBuddy(self);
        end;
if (copy(data,1,3)='REA')  then begin
FUserFriendlyName:=SplitString(data).data[4];

FMSNUserInformation.UserId:=FUserID;
FMSNUserInformation.Password:=FPassword;
FMSNUserInformation.FriendlyName:=FUserFriendlyName;
FMSNUserInformation.Status:=FUserStatus;

If Assigned(OnUserInformationChanged) then OnUserInformationChanged(self);

end;
if (copy(data,1,3)='REM') or (copy(data,1,3)='ADD') then begin

if (pos('FL',data)<>0) and (FriendsListChanged=False) then refreshlists;
if (pos('BL',data)<>0) and (FriendsListChanged=False) then refreshlists;

  end;

if copy(data,1,3)='ILN' then begin
//User Online
DecodeListILN(Data);
for i :=0 to length(onlineuserz)-1 do begin

AddOnlineUser(SplitString(OnlineUserz[i]).data[3],SplitString(OnlineUserz[i]).data[2]);
end;

refreshlists;
end;


if copy(data,1,3)='FLN' then begin
//FLN 10 FLN deaxxxx@hotmail.com
AddOnlineUser(SplitString(data).data[3],SplitString(data).data[2]);
If Assigned(OnUserWentOffline) then OnUserWentOffline(Self);
refreshlists;
end;

if copy(data,1,3)='NLN' then begin
//New User Logged On
AddOnlineUser(SplitString(data).data[2],SplitString(data).data[1]);

If Assigned(OnUserWentOnline) then OnUserWentOnline(Self);
refreshlists;
end;




end;

////////////////////////////////////////////////////////////////////////////////
//End of MSN Messenger Interface Commands
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//Core Commands
////////////////////////////////////////////////////////////////////////////////

Function TMSNMessenger.CustomUser(FriendlyName,Email,Status,Phone,WorkPhone,Mobile,MSNMobile,Group:String):TBuddy;
begin
Result.FriendlyName:=StringReplace(FriendlyName,'%20',' ',[rfReplaceAll]);
Result.EmailAddress:=Email;
Result.PhoneNumber:=StringReplace(Phone,'%20',' ',[rfReplaceAll]);
Result.WorkNumber:=StringReplace(WorkPhone,'%20',' ',[rfReplaceAll]);
Result.MobileNumber:=StringReplace(Mobile,'%20',' ',[rfReplaceAll]);
Result.MSNMobile:=StringReplace(MSNMobile,'%20',' ',[rfReplaceAll]);
if group<>'' then Result.Group:=Strtoint(Group);
end;

function TMSNMessenger.Xid:string;
begin
fid:=fid+1;
result:=inttostr(fid);
end;

Procedure TMSnMessenger.GetLists;
begin
if Loggedon then  sendmessage('SYN '+xid+' 0');
end;


Procedure TMsnMessenger.SendMessage(Data:String);
var
d:string;
begin
d:=data+beep;
MSN.Send(pchar(D),Length(d));
writedata:=data;
if assigned(OnWriteData) then OnWriteData(self);

end;

Function TMsnMessenger.MD5(Data:String):String;
begin
Result:=md5hash.HashToDisplay(md5hash.HashString(DATA));
end;


////////////////////////////////////////////////////////////////////////////////
//Component List Management
////////////////////////////////////////////////////////////////////////////////

Procedure TMSNMEssenger.AddOnlineUser(Email,Status:String);
var
i:integer;
ii:integer;
begin
ii:=-1;
for i:=0 to Length(MSNOnlineUsers)-1 do begin

if Lowercase(MSNOnlineUsers[i].email)=lowercase(Email) then begin
ii:=i;
end;

end;
//showmessage(Email+':'+Status+'/'+inttostr(ii));

if ii<>-1 then MSNOnlineUsers[ii].Status:=Status else begin
setlength(MSNOnlineUsers,Length(MSNOnlineUsers)+1);
MSNOnlineUsers[Length(MSNOnlineUsers)-1].email:=email;
MSNOnlineUsers[Length(MSNOnlineUsers)-1].Status:=Status;

end;

end;

Function TMsnMessenger.AddUserToList(BuddyList:TBuddyList;User:Tbuddy):TBuddyList;
var
i,ii:integer;
begin
Buddylist:=RemoveUserFromList(Buddylist,User);

ii:=-1;
for i:=0 to length(Buddylist.BuddiesOnList)-1 do begin
if lowercase(buddylist.buddiesonlist[i].EmailAddress)=lowercase(user.EmailAddress) then ii:=i;
end;

if ii<>-1 then begin

Buddylist.BuddiesOnList[ii]:=user;

end else begin

SetLength(Buddylist.BuddiesOnList,Length(Buddylist.BuddiesOnList)+1);

Buddylist.BuddiesOnList[length(Buddylist.BuddiesOnList)-1]:=User;


setlength(result.BuddiesOnList,length(buddylist.BuddiesOnList));

end;
result.BuddiesOnList:=buddylist.BuddiesOnList;
end;

Function TMsnMessenger.RemoveUserFromList(BuddyList:TBuddyList;User:Tbuddy):TBuddyList;
var
i,ii:integer;
begin
i:=0;
while i<length(buddylist.BuddiesOnList) do begin
if lowercase(buddylist.buddiesonlist[i].EmailAddress)=lowercase(user.EmailAddress) then begin

for ii:=i to length(buddylist.BuddiesOnList)-2 do begin
buddylist.BuddiesOnList[ii]:=buddylist.BuddiesOnList[ii+1];

end;

SetLength(Buddylist.BuddiesOnList,Length(Buddylist.BuddiesOnList)-1);
end else

inc(i);
end;
result:=Buddylist;
end ;

////////////////////////////////////////////////////////////////////////////////
//Core Component Commands
////////////////////////////////////////////////////////////////////////////////

{Registration}
procedure Register;
begin
  RegisterComponents('Digital Realms', [TMsnMessenger]);
end;

Procedure TMsnMessenger.Initialize;
Begin

MSN:=TSimpleTCPClient.Create(Self);
MD5Hash:=THashAlgMD5.Create(Self);
ListTimer:=TTImer.Create(self);
ListTimer.Interval:=500;
ListTimer.Enabled:=false;
ListTimer.OnTimer:=OnListTimer;

Timer:=TTImer.Create(self);
Timer.Interval:=1000;
Timer.Enabled:=false;
Timer.OnTimer:=OnTimer;
MSN.OnConnected:=SimpleTCPClient1Connected;
//MSN.AutoTryReconnect:=true;
msn.OnDisconnected:=SimpleTCPClient1Disconnected;
//msn.OnDataAvailable:=SimpleTCPClient1DataAvailable;
msn.OnRead:=SimpleTCPClient1Read;
//msn.OnError:=SimpleTCPClient1Error;
MSN.Connected:=false;
End;


{Virutal component Commands}
procedure TMsnMessenger.OnListTimer(Sender: TObject);

begin
ListTimer.Enabled:=false;
if assigned(OnListChange) then OnListChange(self);
end;

procedure TMsnMessenger.OnTimer(Sender: TObject);
begin
timer.Enabled:=false;
Msn.Connected:=true;

end;

    procedure TMsnMessenger.SimpleTCPClient1Connected(Sender: TObject);
Begin
sendmessage('VER 0 MSNP7 MSNP6 MSNP5 MSNP4 CVRO');

End;

procedure TMsnMessenger.SimpleTCPClient1Read(Sender: TObject; Stream: TStream);
var
data:string;
begin
try
//Recieved Data
  with Stream as TMemoryStream do
   begin
    SetLength(DATA, Size);
    Read(DATA[1], Size);
   end;
readdata:=data;
if assigned(OnreadData) then OnReadData(self);

//Do Tests
If FLoggedIn then processcommand(data) else processlogin(data);


except
end;


end;

    procedure TMsnMessenger.SimpleTCPClient1Disconnected(Sender: TObject);
Begin
Floggedin:=false;
if assigned(onLogout) then OnLogout(self);
If Assigned(OnDisconnect) then OnDisconnect(self);
End;

    procedure TMsnMessenger.SimpleTCPClient1Error(Sender: TObject; Socket,
      ErrorCode: Integer; ErrorMsg: String);
Begin
ErrorCode:=0;
FMSNStatus:=ErrorMsg;
If Assigned(OnError) then OnError(self);
End;


////////////////////////////////////////////////////////////////////////////////
//User Commands
////////////////////////////////////////////////////////////////////////////////

Procedure TMsnMessenger.MSNLogin;
Begin
if msn.Connected=false then begin
MSn.Host:='messenger.hotmail.com';
Msn.Port:=1863;
msn.Connected:=true;
If Assigned(OnConnect) then OnConnect(self);
end;


End;


Procedure TMsnMessenger.MSNLogout;
Begin
MSN.Connected:=false;
FLoggedin:=false;
If Assigned(OnLogout) then OnLogout(self);
End;


Procedure TMsnMessenger.RefreshLists;
begin
//clear lists
setlength(listdata,0);
SetLength(MSNListFriends.BuddiesOnList,0);
SetLength(MSNListBlocked.BuddiesOnList,0);
SetLength(MSNListAddedYou.BuddiesOnList,0);
SetLength(MSNListSeeYou.BuddiesOnList,0);
if Loggedon then  GetLists;

end;

Procedure TMsnMessenger.MSNInviteBuddy(EmailAddress:String);
Begin
Sendmessage('XFR '+XID+' SB');
ChatSession.ChatPartner:=EmailAddress;
End;


Procedure TMsnMessenger.MSNChangeStatus(NewStatus:String);
Begin
if Loggedon then  Sendmessage('CHG '+Xid+' '+NewStatus);
Fuserstatus:=NewStatus;

FMSNUserInformation.UserId:=FUserID;
FMSNUserInformation.Password:=FPassword;
FMSNUserInformation.FriendlyName:=FUserFriendlyName;
FMSNUserInformation.Status:=FUserStatus;

If Assigned(OnUserInformationChanged) then OnUserInformationChanged(self);
End;


Procedure TMsnMessenger.MSNAddBuddy(EmailAddress:String);
Begin
if Loggedon then  SendmEssage('ADD '+XID+' AL '+emailaddress+' ' +emailaddress);
if Loggedon then  SendmEssage('ADD '+XID+' RL '+emailaddress+' ' +emailaddress);
If Loggedon then  SendmEssage('ADD '+XID+' FL '+emailaddress+' ' +emailaddress+' 0');
RefreshLists;
If Assigned(OnAddedUser) then OnAddedUser(self);

End;


Procedure TMsnMessenger.MSNRemoveBuddy(EmailAddress:String);
Begin
if Loggedon then  SendmEssage('REM '+XID+' FL '+emailaddress+' 0');
if Loggedon then  SendmEssage('REM '+XID+' AL '+emailaddress);
if Loggedon then  SendmEssage('REM '+XID+' RL '+emailaddress);
RefreshLists;
If Assigned(Ondeleteduser) then OnDeletedUser(self);
End;


Procedure TMsnMessenger.MSNBlockBuddy(EmailAddress:String);
Begin
if Loggedon then  SendmEssage('REM '+XID+' AL '+emailaddress);
if Loggedon then  SendmEssage('ADD '+XID+' BL '+emailaddress+' ' +emailaddress);
RefreshLists;
If Assigned(OnBlockUser) then OnBlockUser(self);
End;


Procedure TMsnMessenger.MSNUnBlockBuddy(EmailAddress:String);
Begin

if Loggedon then  SendmEssage('REM '+XID+' BL '+emailaddress);
if Loggedon then  SendmEssage('ADD '+XID+' AL '+emailaddress+' ' +emailaddress);
If Assigned(OnUnblockUser) then OnUnblockUser(self);
RefreshLists;
End;


Procedure TMsnMessenger.MSNChageName (NewName:String);
Begin
//>>> REA 25 example@passport.com My%20New%20Name

if Loggedon then  Sendmessage('REA '+Xid+' '+FUserID+' '+StringReplace(NewName,' ','%20',[rfReplaceAll]));
If Assigned(OnUserInformationChanged) then OnUserInformationChanged(self);
End;




end.
